#include "string.h"
#include "stdlib.h"

#include "SDL.h"
#include "SDL_ttf.h"

#include "BList.h"
#include "auxiliar.h"

#include "valuescript.h"
#include "conditionscript.h"
#include "actionscript.h"
#include "variables.h"
#include "mog2.h"
#include "object.h"

#include "BWindow.h"
#include "BActiveWindow.h"
#include "BChoiceDlg.h"
#include "OVariableWnd.h"
#include "ConditionScriptWnd.h"
#include "ActionScriptWnd.h"
#include "ActionEditorWnd.h"
#include "interfaces.h"

#include "BFileListWnd.h"
#include "BFileDlg.h"

#include "editor.h"

#ifdef KITSCHY_DEBUG_MEMORY 
#include "debug_memorymanager.h"
#endif

BActionEditorWnd::BActionEditorWnd(int x,int y,int dx,int dy,ActionSCRIPT **a_os,ConditionSCRIPT **c_os,ValueSCRIPT **v_os,EDITOR *editor,int level,TTF_Font *font) : BActiveWindow(x,y,dx,dy,font)
{
	BButton *b;
	int but_dx;

	but_dx=get_text_width("ACCEPT",font)+10;
	b=new BButton(20,dy-20,but_dx,12,"ACCEPT",1);
	buttons.Add(b);

	but_dx=get_text_width("CANCEL",font)+10;
	b=new BButton(120,dy-20,but_dx,12,"CANCEL",2);
	buttons.Add(b);

	but_dx=get_text_width("SAVE BMP",font)+10;
	b=new BButton(320,dy-20,but_dx,12,"SAVE BMP",3);
	buttons.Add(b);

	if (a_os!=0) {
		a_script=new ActionSCRIPT(**a_os);
		a_output_script=a_os;
	} else {
		a_script=0;
		a_output_script=0;
	} /* if */ 
	if (c_os!=0) {
		c_script=new ConditionSCRIPT(**c_os);
		c_output_script=c_os;
	} else {
		c_script=0;
		c_output_script=0;
	} /* if */ 
	if (v_os!=0) {
		v_script=new ValueSCRIPT(**v_os);
		v_output_script=v_os;
	} else {
		v_script=0;
		v_output_script=0;
	} /* if */ 

	vsw=new BViewActionScriptWnd(10,10,dx-20,dy-60,a_script,c_script,v_script,editor->ov_selected,editor->room,editor->map,editor->game,editor->interf,editor,level,font);

} /* BActionEditorWnd::BActionEditorWnd */ 


BActionEditorWnd::~BActionEditorWnd()
{
	delete vsw;
	delete a_script;
	delete c_script;
	delete v_script;

} /* BActionEditorWnd::BActionEditorWnd */ 


void BActionEditorWnd::contens_size(int *dx,int *dy)
{
	*dx=old_dx;
	*dy=old_dy;
} /* BActionEditorWnd::contens_size */ 



bool BActionEditorWnd::cycle(int stx,int sty)
{
	if (!BActiveWindow::cycle(stx,sty)) return false;

	vsw->cycle(stx+10,sty+10);
	if (vsw->is_dirty()) set_dirty();

	return true;
} /* BActionEditorWnd::cycle */ 



void BActionEditorWnd::draw_contens(SDL_Surface *sfc,int stx,int sty,int dx,int dy)
{
	SDL_Rect r;

	SDL_FillRect(sfc,0,0x0000007f);

	r.x=1-stx;
	r.y=1-sty;
	r.w=dx-2;
	r.h=dy-2;
	SDL_FillRect(sfc,&r,0x000000ff);

	BActiveWindow::draw_contens(sfc,stx,sty,dx,dy);

	vsw->draw(sfc,10-stx,10-sty,dx-20,dy-60);

} /* BActionEditorWnd::draw_contens */ 


bool BActionEditorWnd::button_pressed(int ID)
{
	switch(ID) {
	case 1:
		if (a_output_script!=0) {
			delete *a_output_script;
			*a_output_script=a_script;
		} /* if */ 
		a_script=0;
		if (c_output_script!=0) {
			delete *c_output_script;
			*c_output_script=c_script;
		} /* if */ 
		c_script=0;
		if (v_output_script!=0) {
			delete *v_output_script;
			*v_output_script=v_script;
		} /* if */ 
		v_script=0;
		return false;
		break;

	case 2:
		return false;
		break;

	case 3:
		/* SAVE: */ 
		{
			char tmp[256]="*.bmp";
			BFileDlg *dlg=new BFileDlg(30,30,200,200,"Save script image","Save",tmp,font);

			dlg->Execute();
			delete dlg;

			if (tmp[0]!=0) {
				FILE *fp;
				int res=0;

				fp=fopen(tmp,"r");
				if (fp!=0) {
					fclose(fp);
					fp=0;

					BChoiceDlg *dlg2=new BChoiceDlg(40,40,200,50,"File already exist!","Overwrite",&res,font);
					dlg2->Execute();
					delete dlg2;

					fclose(fp);
					if (res==1) vsw->save_bmp(tmp);
				} else {
					vsw->save_bmp(tmp);
				} /* if */ 
				
			} /* if */ 
		}
		return false;
		break;

	} /* switch */ 

	return false;
} /* BActionEditorWnd::button_pressed */ 

